/*******************************************************************************
 *  Copyright CONSORTIUM COCKTAIL (www.cocktail.org), 1995, 2008
 *  
 *  This software is governed by the CeCILL license under French law and abiding
 *  by the rules of distribution of free software. You can use, modify and/or
 *  redistribute the software under the terms of the CeCILL license as circulated
 *  by CEA, CNRS and INRIA at the following URL "http://www.cecill.info".
 *  
 *  As a counterpart to the access to the source code and rights to copy, modify
 *  and redistribute granted by the license, users are provided only with a
 *  limited warranty and the software's author, the holder of the economic
 *  rights, and the successive licensors have only limited liability.
 *  
 *  In this respect, the user's attention is drawn to the risks associated with
 *  loading, using, modifying and/or developing or reproducing the software by
 *  the user in light of its specific status of free software, that may mean that
 *  it is complicated to manipulate, and that also therefore means that it is
 *  reserved for developers and experienced professionals having in-depth
 *  computer knowledge. Users are therefore encouraged to load and test the
 *  software's suitability as regards their requirements in conditions enabling
 *  the security of their systems and/or data to be ensured and, more generally,
 *  to use and operate it in the same conditions as regards security.
 *  
 *  The fact that you are presently reading this means that you have had
 *  knowledge of the CeCILL license and that you accept its terms.
 * 
 *******************************************************************************/

package org.cocktail.sapics.client.gui;

import java.awt.BorderLayout;
import java.util.Vector;

import javax.swing.BorderFactory;
import javax.swing.JScrollPane;
import javax.swing.ListSelectionModel;
import javax.swing.SwingConstants;

import org.cocktail.application.client.eof.EOOrgan;
import org.cocktail.sapics.client.eof.model.EOLotOrgan;
import org.cocktail.sapics.client.swing.TableSorter;
import org.cocktail.sapics.client.swing.ZEOTable;
import org.cocktail.sapics.client.swing.ZEOTableModel;
import org.cocktail.sapics.client.swing.ZEOTableModelColumn;
import org.cocktail.sapics.client.utilities.CocktailConstantes;

import com.webobjects.eointerface.EODisplayGroup;

/**
 *
 * @author  cpinsard
 */
public class LotOrganView extends javax.swing.JPanel {

	/**
	 * 
	 */
	private static final long serialVersionUID = 4457597315858683937L;

	protected EODisplayGroup eodOrgan;

	protected ZEOTable myEOTableOrgan;
	protected ZEOTableModel myTableModelOrgan ;
	protected TableSorter myTableSorterOrgan;

	/** Creates new form TemplateJPanel */
	public LotOrganView(EODisplayGroup dg) {

		eodOrgan = dg;

		initComponents();
		initGui();

	}


	/** This method is called from within the constructor to
	 * initialize the form.
	 * WARNING: Do NOT modify this code. The content of this method is
	 * always regenerated by the Form Editor.
	 */

    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        viewTableOrgan = new javax.swing.JPanel();
        btnAddOrgan = new javax.swing.JButton();
        btnDelOrgan = new javax.swing.JButton();

        viewTableOrgan.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));
        viewTableOrgan.setLayout(new java.awt.BorderLayout());

        btnAddOrgan.setToolTipText("Ajout d'une ligne budgétaire");

        btnDelOrgan.setToolTipText("Suppression de la ligne budgétaire sélectionnée");

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .add(132, 132, 132)
                .add(viewTableOrgan, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 594, Short.MAX_VALUE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING, false)
                    .add(org.jdesktop.layout.GroupLayout.LEADING, btnDelOrgan, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 22, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(org.jdesktop.layout.GroupLayout.LEADING, btnAddOrgan, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 22, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .add(135, 135, 135))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .add(21, 21, 21)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(viewTableOrgan, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 144, Short.MAX_VALUE)
                    .add(layout.createSequentialGroup()
                        .add(btnAddOrgan, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 22, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(btnDelOrgan, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 22, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)))
                .add(24, 24, 24))
        );
    }// </editor-fold>//GEN-END:initComponents


    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton btnAddOrgan;
    private javax.swing.JButton btnDelOrgan;
    protected javax.swing.JPanel viewTableOrgan;
    // End of variables declaration//GEN-END:variables




	private void initGui() {

		btnAddOrgan.setIcon(CocktailConstantes.ICON_ADD);
		btnDelOrgan.setIcon(CocktailConstantes.ICON_DELETE);

		Vector<ZEOTableModelColumn> myCols = new Vector<ZEOTableModelColumn>();

		ZEOTableModelColumn col = new ZEOTableModelColumn(eodOrgan, EOLotOrgan.ORGAN_KEY+"."+EOOrgan.ORG_UB_KEY, "UB", 50);
		col.setAlignment(SwingConstants.LEFT);
		myCols.add(col);

		col = new ZEOTableModelColumn(eodOrgan, EOLotOrgan.ORGAN_KEY+"."+EOOrgan.ORG_CR_KEY, "CR", 30);
		col.setAlignment(SwingConstants.LEFT);
		myCols.add(col);

		col = new ZEOTableModelColumn(eodOrgan, EOLotOrgan.ORGAN_KEY+"."+EOOrgan.ORG_SOUSCR_KEY, "Sous CR", 70);
		col.setAlignment(SwingConstants.LEFT);
		myCols.add(col);

		col = new ZEOTableModelColumn(eodOrgan, EOLotOrgan.LO_MONTANT_KEY, "Montant", 75);
		col.setAlignment(SwingConstants.RIGHT);
		myCols.add(col);
		
		myTableModelOrgan = new ZEOTableModel(eodOrgan, myCols);
		myTableSorterOrgan = new TableSorter(myTableModelOrgan);

		myEOTableOrgan = new ZEOTable(myTableSorterOrgan);
		//myEOTableNuits.addListener(myListenerContrat);
		myTableSorterOrgan.setTableHeader(myEOTableOrgan.getTableHeader());		

		myEOTableOrgan.setBackground(CocktailConstantes.COLOR_BKG_TABLE_VIEW);
		myEOTableOrgan.setSelectionBackground(CocktailConstantes.COLOR_SELECTED_ROW);
		myEOTableOrgan.setSelectionMode(ListSelectionModel.MULTIPLE_INTERVAL_SELECTION);

		viewTableOrgan.setLayout(new BorderLayout());
		viewTableOrgan.setBorder(BorderFactory.createEmptyBorder(2,2,2,2));
		viewTableOrgan.removeAll();
		viewTableOrgan.add(new JScrollPane(myEOTableOrgan), BorderLayout.CENTER);




	}


	public ZEOTable getMyEOTableOrgan() {
		return myEOTableOrgan;
	}


	public void setMyEOTableOrgan(ZEOTable myEOTableOrgan) {
		this.myEOTableOrgan = myEOTableOrgan;
	}


	public javax.swing.JButton getBtnAddOrgan() {
		return btnAddOrgan;
	}


	public void setBtnAddOrgan(javax.swing.JButton btnAddOrgan) {
		this.btnAddOrgan = btnAddOrgan;
	}


	public javax.swing.JButton getBtnDelOrgan() {
		return btnDelOrgan;
	}


	public void setBtnDelOrgan(javax.swing.JButton btnDelOrgan) {
		this.btnDelOrgan = btnDelOrgan;
	}



}

